VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "howto_primes_fractal"
   ClientHeight    =   11190
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   11880
   LinkTopic       =   "Form1"
   ScaleHeight     =   11190
   ScaleWidth      =   11880
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog dlgSaveFile 
      Left            =   5880
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DefaultExt      =   ".bmp"
      Filter          =   "Bitmap Files|*.bmp|All FIles|*.*"
   End
   Begin VB.PictureBox picFractal 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      Height          =   10695
      Left            =   120
      ScaleHeight     =   10635
      ScaleWidth      =   11595
      TabIndex        =   0
      Top             =   360
      Width           =   11655
   End
   Begin VB.Label lblPrime 
      AutoSize        =   -1  'True
      Height          =   195
      Left            =   3480
      TabIndex        =   4
      Top             =   120
      Width           =   45
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Prime:"
      Height          =   195
      Index           =   1
      Left            =   2880
      TabIndex        =   3
      Top             =   120
      Width           =   435
   End
   Begin VB.Label lblNumPoints 
      AutoSize        =   -1  'True
      Height          =   195
      Left            =   840
      TabIndex        =   2
      Top             =   120
      Width           =   45
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "# Points:"
      Height          =   195
      Index           =   0
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   630
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileStart 
         Caption         =   "&Start"
         Shortcut        =   {F5}
      End
      Begin VB.Menu mnuFileSaveAs 
         Caption         =   "Save &As..."
         Shortcut        =   ^S
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const Wid As Integer = 800
Private Const Hgt As Integer = 800
Private Const XOff As Integer = 150
Private Const YOff As Integer = 200
Private Hits(Wid, Hgt) As Integer
Private CurX As Integer
Private CurY As Integer
Private CurrentPrime As Long

Private Running As Boolean
Private NumPoints As Long

' Initialize data structures.
Private Sub Form_Load()
    CurX = 0
    CurY = 0
    CurrentPrime = 1
    Running = False
    NumPoints = 0
    picFractal.ScaleMode = vbPixels
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Running = False
    End
End Sub

' Save the image.
Private Sub mnuFileSaveAs_Click()
    On Error Resume Next
    dlgSaveFile.ShowSave
    If Err.Number = ErrorConstants.cdlCancel Then Exit Sub
    If Err.Number <> 0 Then
        MsgBox "Error " & Err.Number & " selecting file." & vbCrLf & Err.Description
        Exit Sub
    End If
    
    SavePicture picFractal.Image, dlgSaveFile.FileName
End Sub

' Start or stop.
Private Sub mnuFileStart_Click()
    If (mnuFileStart.Caption = "&Start") Then
        ' Start.
        Running = True
        mnuFileStart.Caption = "&Stop"

        DrawFractal

        ' Clean up after we finish running.
        mnuFileStart.Enabled = True
        mnuFileStart.Caption = "&Start"
    Else
        ' Stop.
        Running = False
        mnuFileStart.Enabled = False
    End If
End Sub

' Add points to the fractal.
Private Sub DrawFractal()
Const points_per_loop As Integer = 10000
    
Dim i As Integer
Dim ix As Integer
Dim iy As Integer

    Do While (Running)
        ' Generate a bunch of points.
        For i = 1 To points_per_loop
            ' Find the next prime.
            CurrentPrime = FindNextPrime(CurrentPrime)

            ' See which kind of prime it is.
            Select Case (CurrentPrime Mod 5)
                Case 1
                    CurY = CurY - 1
                Case 2
                    CurX = CurX + 1
                Case 3
                    CurY = CurY + 1
                Case 4
                    CurX = CurX - 1
            End Select

            ' Record the hit.
            ix = CurX + XOff
            iy = CurY + YOff
            If (ix >= 0 And iy >= 0 And ix < Wid And iy < Hgt) Then
                Hits(ix, iy) = Hits(ix, iy) + 1
            End If
        Next i

        ' Build the image.
        BuildImage

        ' Display the point count.
        NumPoints = NumPoints + points_per_loop
        lblNumPoints.Caption = NumPoints
        lblPrime.Caption = CurrentPrime

        ' Process button clicks if there were any.
        DoEvents
    Loop
End Sub

' Find the next prime after this one.
Private Function FindNextPrime(ByVal value As Long) As Long
Dim i As Long
    
    ' Cheat a little for speed.
    'if (value = 1) return 2
    'if (value = 2) return 3
    i = value + 2
    Do
        If (IsPrime(i)) Then
            FindNextPrime = i
            Exit Do
        End If
        i = i + 2
    Loop
End Function

' Return true of the value is prime.
' For speed, asssume value > 2 and value is odd.
Private Function IsPrime(ByVal value As Long) As Boolean
Dim stop_at As Long
Dim factor As Long

    IsPrime = False
    stop_at = Int(Sqr(value))
    For factor = 3 To stop_at Step 2
        If (value Mod factor = 0) Then Exit Function
    Next factor
    IsPrime = True
End Function

' Build and display the image.
Private Sub BuildImage()
Dim max As Integer
Dim x As Integer
Dim y As Integer
Dim fmax As Single

    ' Find the largest hit value.
    max = 0
    For x = 0 To Wid - 1
        For y = 0 To Hgt - 1
            If (max < Hits(x, y)) Then max = Hits(x, y)
        Next y
    Next x

    ' Plot the hits.
    picFractal.Cls
    fmax = max
    For x = 0 To Wid - 1
        For y = 0 To Hgt - 1
            If (Hits(x, y) > 0) Then
                picFractal.PSet (x, y), MapRainbowColor(Hits(x, y), 1, fmax)
            End If
        Next y
    Next x

    ' Draw the axes.
    picFractal.Line (XOff, 0)-(XOff, Hgt), vbBlue
    picFractal.Line (0, YOff)-(Wid, YOff), vbBlue

    ' Display the result.
    picFractal.Refresh
End Sub

' Map a value to a rainbow color.
Private Function MapRainbowColor(ByVal value As Single, ByVal red_value As Single, ByVal blue_value As Single) As OLE_COLOR
Dim int_value As Integer
    
    ' Convert into a value between 0 and 1023.
    int_value = Int(1023 * (value - red_value) / (blue_value - red_value))

    ' Map different color bands.
    If (int_value < 256) Then
        ' Red to yellow. (255, 0, 0) to (255, 255, 0).
        MapRainbowColor = RGB(255, int_value, 0)
    ElseIf (int_value < 512) Then
        ' Yellow to green. (255, 255, 0) to (0, 255, 0).
        int_value = int_value - 256
        MapRainbowColor = RGB(255 - int_value, 255, 0)
    ElseIf (int_value < 768) Then
        ' Green to aqua. (0, 255, 0) to (0, 255, 255).
        int_value = int_value - 512
        MapRainbowColor = RGB(0, 255, int_value)
    Else
        ' Aqua to blue. (0, 255, 255) to (0, 0, 255).
        int_value = int_value - 768
        MapRainbowColor = RGB(0, 255 - int_value, 255)
    End If
End Function

